﻿Imports fecllib

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim wsfecl As New fecllib.Fecl
        Dim ArchivoCertificado As String = wsfecl.RutaLibreria + "recursos\certificado.pfx"
        Dim Clave As String = "feafip"

        wsfecl.ModoProduccion = False
        wsfecl.ModoSimulacion = True ' Cambiar a falso para trabajar con servidores reales de SII

        Try
            If Not wsfecl.Autenticar(ArchivoCertificado, Clave) Then
                Throw New Exception(wsfecl.ErrorDesc)
            End If

            Dim vEnvio As fecllib.EnvioDTE = wsfecl.NuevoEnvioDTE
            vEnvio.ArchivoCertificado = ArchivoCertificado
            vEnvio.ArchivoClave = Clave

            'Descripcion: www.sii.cl/factura_electronica/factura_mercado/formato_dte.pdf
            'Diagrama: www.bitingenieria.com.ar/doc/descripcion_dte

            vEnvio.SDTE.Nodo("Caratula").Str("RutEmisor") = "22222222-2"
            vEnvio.SDTE.Nodo("Caratula").Str("RutEnvia") = "11111111-1"
            vEnvio.SDTE.Nodo("Caratula").Str("RutReceptor") = "60803000-K"
            vEnvio.SDTE.Nodo("Caratula").Str("FchResol") = "2016-04-27"
            vEnvio.SDTE.Nodo("Caratula").Int("NroResol") = 0
            vEnvio.SDTE.Nodo("Caratula").Str("TmstFirmaEnv") = ""
            vEnvio.SDTE.Nodo("Caratula").Nodos("SubTotDTE", 0).Int("TpoDTE") = 33
            vEnvio.SDTE.Nodo("Caratula").Nodos("SubTotDTE", 0).Int("NroDTE") = 1

            Dim vDoc As Nodo = vEnvio.SDTE.Nodos("DTE", 0).Nodo("Documento")

            vDoc.Nodo("Encabezado").Nodo("IdDoc").Int("TipoDTE") = vEnvio.SDTE.Nodo("Caratula").Nodos("SubTotDTE", 0).Int("TpoDTE")
            vDoc.Nodo("Encabezado").Nodo("IdDoc").Int("Folio") = 1
            vDoc.Nodo("Encabezado").Nodo("IdDoc").Str("FchEmis") = "2017-08-31"

            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("RUTEmisor") = vEnvio.SDTE.Nodo("Caratula").Str("RutEmisor")
            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("RznSoc") = "Razon social emisor"
            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("GiroEmis") = "Venta de articulos de cotillón"
            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("Acteco") = "11111"
            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("DirOrigen") = "Direccion Origen 123s4"
            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("CmnaOrigen") = "Santiago"

            vDoc.Nodo("Encabezado").Nodo("Receptor").Str("RUTRecep") = vEnvio.SDTE.Nodo("Caratula").Str("RutReceptor")
            vDoc.Nodo("Encabezado").Nodo("Receptor").Str("RznSocRecep") = "Receptor del documento"
            vDoc.Nodo("Encabezado").Nodo("Receptor").Str("GiroRecep") = "Giro Receptor"
            vDoc.Nodo("Encabezado").Nodo("Receptor").Str("DirRecep") = "Direccion del receptor"
            vDoc.Nodo("Encabezado").Nodo("Receptor").Str("CmnaRecep") = "Comuna Receptor"


            vDoc.Nodo("Encabezado").Nodo("Totales").Dbl("MntNeto") = 171639
            vDoc.Nodo("Encabezado").Nodo("Totales").Dbl("TasaIVA") = 19
            vDoc.Nodo("Encabezado").Nodo("Totales").Dbl("IVA") = 32611
            vDoc.Nodo("Encabezado").Nodo("Totales").Dbl("MntTotal") = 204250

            vDoc.Nodos("Detalle", 0).Int("NroLinDet") = 1
            vDoc.Nodos("Detalle", 0).Nodo("CdgItem").Str("TpoCodigo") = "INT1"
            vDoc.Nodos("Detalle", 0).Nodo("CdgItem").Str("VlrCodigo") = "011"
            vDoc.Nodos("Detalle", 0).Str("NmbItem") = "Cajón AFECTO"
            vDoc.Nodos("Detalle", 0).Int("QtyItem") = 122
            vDoc.Nodos("Detalle", 0).Dbl("PrcItem") = 833
            vDoc.Nodos("Detalle", 0).Dbl("MontoItem") = 101626

            vDoc.Nodos("Detalle", 1).Int("NroLinDet") = 2
            vDoc.Nodos("Detalle", 1).Nodo("CdgItem").Str("TpoCodigo") = "INT2"
            vDoc.Nodos("Detalle", 1).Nodo("CdgItem").Str("VlrCodigo") = "0231"
            vDoc.Nodos("Detalle", 1).Str("NmbItem") = "Relleno AFECTO"
            vDoc.Nodos("Detalle", 1).Int("QtyItem") = 53
            vDoc.Nodos("Detalle", 1).Dbl("PrcItem") = 1321
            vDoc.Nodos("Detalle", 1).Dbl("MontoItem") = 70013

            vDoc.Nodo("TED").Nodo("DD").Str("RE") = vDoc.Nodo("Encabezado").Nodo("Emisor").Str("RUTEmisor")
            vDoc.Nodo("TED").Nodo("DD").Int("TD") = vDoc.Nodo("Encabezado").Nodo("IdDoc").Int("TipoDTE")
            vDoc.Nodo("TED").Nodo("DD").Int("F") = vDoc.Nodo("Encabezado").Nodo("IdDoc").Int("Folio")
            vDoc.Nodo("TED").Nodo("DD").Str("FE") = vDoc.Nodo("Encabezado").Nodo("IdDoc").Str("FchEmis")
            vDoc.Nodo("TED").Nodo("DD").Str("RR") = vDoc.Nodo("Encabezado").Nodo("Receptor").Str("RUTRecep")
            vDoc.Nodo("TED").Nodo("DD").Str("RSR") = vDoc.Nodo("Encabezado").Nodo("Receptor").Str("RznSocRecep")
            vDoc.Nodo("TED").Nodo("DD").Dbl("MNT") = vDoc.Nodo("Encabezado").Nodo("Totales").Dbl("MntTotal")
            vDoc.Nodo("TED").Nodo("DD").Str("IT1") = vDoc.Nodos("Detalle", 0).Str("NmbItem")

            If Not vEnvio.AgregarTED(wsfecl.RutaLibreria + "recursos\folio_dte.xml") Then
                Throw New Exception(vEnvio.ErrorDesc)
            End If

            If Not vEnvio.Firmar() Then
                Throw New Exception(vEnvio.ErrorDesc)
            End If

            If Not wsfecl.EnviarDTE() Then
                Throw New Exception(vEnvio.ErrorDesc)
            End If

            vEnvio.Impresion.AbrirArchivo = True
            If Not vEnvio.Impresion.Generar(0, wsfecl.RutaLibreria + "pdf\dte.pdf", wsfecl.RutaLibreria + "recursos\plantilla_dte.rtm", "PDF") Then
                Throw New Exception(vEnvio.Impresion.ErrorDesc)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click

        Dim wsfecl As New fecllib.Fecl
        Dim ArchivoCertificado As String = wsfecl.RutaLibreria + "recursos\certificado.pfx"
        Dim Clave As String = "feafip"

        wsfecl.ModoProduccion = False
        wsfecl.ModoSimulacion = True ' Cambiar a falso para trabajar con servidores reales de SII

        Try
            If Not wsfecl.Autenticar(ArchivoCertificado, Clave) Then
                Throw New Exception(wsfecl.ErrorDesc)
            End If

            Dim vEnvioBoleta As fecllib.EnvioBoleta = wsfecl.NuevoEnvioBoleta
            vEnvioBoleta.ArchivoCertificado = ArchivoCertificado
            vEnvioBoleta.ArchivoClave = Clave

            'Descripcion: www.sii.cl/factura_electronica/factura_mercado/boletas_elec_0720_3.pdf
            'Diagrama: www.bitingenieria.com.ar/doc/boletas_elec

            vEnvioBoleta.SetDTE.Nodo("Caratula").Str("RutEmisor") = "22222222-2"
            vEnvioBoleta.SetDTE.Nodo("Caratula").Str("RutEnvia") = "11111111-1"
            vEnvioBoleta.SetDTE.Nodo("Caratula").Str("RutReceptor") = "60803000-K"
            vEnvioBoleta.SetDTE.Nodo("Caratula").Str("FchResol") = "2016-04-27"
            vEnvioBoleta.SetDTE.Nodo("Caratula").Int("NroResol") = 0
            vEnvioBoleta.SetDTE.Nodo("Caratula").Str("TmstFirmaEnv") = ""
            vEnvioBoleta.SetDTE.Nodo("Caratula").Nodos("SubTotDTE", 0).Int("TpoDTE") = 39
            vEnvioBoleta.SetDTE.Nodo("Caratula").Nodos("SubTotDTE", 0).Int("NroDTE") = 1

            Dim vDoc As Nodo = vEnvioBoleta.SetDTE.Nodos("DTE", 0).Nodo("Documento")

            vDoc.Nodo("Encabezado").Nodo("IdDoc").Int("TipoDTE") = vEnvioBoleta.SetDTE.Nodo("Caratula").Nodos("SubTotDTE", 0).Int("TpoDTE")
            vDoc.Nodo("Encabezado").Nodo("IdDoc").Int("Folio") = 1
            vDoc.Nodo("Encabezado").Nodo("IdDoc").Str("FchEmis") = "2017-08-31"
            vDoc.Nodo("Encabezado").Nodo("IdDoc").Int("IndServicio") = 3

            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("RUTEmisor") = vEnvioBoleta.SetDTE.Nodo("Caratula").Str("RutEmisor")
            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("RznSocEmisor") = "RAZON_SOCIAL"
            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("GiroEmisor") = "Venta de articulos de cotillón"
            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("DirOrigen") = "Direccion Origen 1234"
            vDoc.Nodo("Encabezado").Nodo("Emisor").Str("CmnaOrigen") = "Santiago"

            vDoc.Nodo("Encabezado").Nodo("Receptor").Str("RUTRecep") = vEnvioBoleta.SetDTE.Nodo("Caratula").Str("RutReceptor")
            vDoc.Nodo("Encabezado").Nodo("Receptor").Str("RznSocRecep") = "Receptor del documento"
            vDoc.Nodo("Encabezado").Nodo("Receptor").Str("DirRecep") = "Direccion Receptor"
            vDoc.Nodo("Encabezado").Nodo("Receptor").Str("CmnaRecep") = "Comuna Receptor"

            vDoc.Nodo("Encabezado").Nodo("Totales").Dbl("MntTotal") = 204250

            vDoc.Nodos("Detalle", 0).Int("NroLinDet") = 1
            vDoc.Nodos("Detalle", 0).Str("NmbItem") = "Cajón AFECTO"
            vDoc.Nodos("Detalle", 0).Dbl("PrcItem") = 833
            vDoc.Nodos("Detalle", 0).Dbl("MontoItem") = 101626

            vDoc.Nodos("Detalle", 1).Int("NroLinDet") = 2
            vDoc.Nodos("Detalle", 1).Str("NmbItem") = "Relleno AFECTO"
            vDoc.Nodos("Detalle", 1).Dbl("PrcItem") = 1321
            vDoc.Nodos("Detalle", 1).Dbl("MontoItem") = 70013

            vDoc.Nodo("TED").Nodo("DD").Str("RE") = vDoc.Nodo("Encabezado").Nodo("Emisor").Str("RUTEmisor")
            vDoc.Nodo("TED").Nodo("DD").Int("TD") = vDoc.Nodo("Encabezado").Nodo("IdDoc").Int("TipoDTE")
            vDoc.Nodo("TED").Nodo("DD").Int("F") = vDoc.Nodo("Encabezado").Nodo("IdDoc").Int("Folio")
            vDoc.Nodo("TED").Nodo("DD").Str("FE") = vDoc.Nodo("Encabezado").Nodo("IdDoc").Str("FchEmis")
            vDoc.Nodo("TED").Nodo("DD").Str("RR") = vDoc.Nodo("Encabezado").Nodo("Receptor").Str("RUTRecep")
            vDoc.Nodo("TED").Nodo("DD").Str("RSR") = vDoc.Nodo("Encabezado").Nodo("Receptor").Str("RznSocRecep")
            vDoc.Nodo("TED").Nodo("DD").Dbl("MNT") = vDoc.Nodo("Encabezado").Nodo("Totales").Dbl("MntTotal")
            vDoc.Nodo("TED").Nodo("DD").Str("IT1") = vDoc.Nodos("Detalle", 0).Str("NmbItem")

            If Not vEnvioBoleta.AgregarTED(wsfecl.RutaLibreria + "recursos\folio_boleta.xml") Then
                Throw New Exception(vEnvioBoleta.ErrorDesc)
            End If

            If Not vEnvioBoleta.Firmar() Then
                Throw New Exception(vEnvioBoleta.ErrorDesc)
            End If

            If Not wsfecl.EnviarBoleta() Then
                Throw New Exception(vEnvioBoleta.ErrorDesc)
            End If

            vEnvioBoleta.Impresion.AbrirArchivo = True
            If Not vEnvioBoleta.Impresion.Generar(0, wsfecl.RutaLibreria + "pdf\boleta.pdf", wsfecl.RutaLibreria + "recursos\plantilla_boleta.rtm", "PDF") Then
                Throw New Exception(vEnvioBoleta.Impresion.ErrorDesc)
            End If
        Catch ex As Exception
            MessageBox.Show(ex.Message)
        End Try

    End Sub

End Class
