  *Para poder evaluar necesitas las siguienets condiciones:
  *- Poseer un certificado y claves en formato PFX o PEM
  *- Poseer un archivo de folios solicitado a SII (https://maullin.sii.cl/cvc_cgi/dte/of_solicita_folios)
  *- Registrar la fecl ejecutando FECLRegistrar.exe
  *- Modificar los datos del emisor en el proyecto acorde a los datos de la empresa (Se pueden obtener de la web de SII)

  * SI EL CERTIFICADO ES PFX 
  #define ArchivoCertificado "C:\Datos\certificado.pfx"
  #define Clave "ClaveCertificado"
  

  * SI EL CERTIFICADO ES CRT(PEM) 
  *#define ArchivoCertificado "C:\Datos\certificado.crt"
  *#define Clave "C:\Datos\certificado.key"
  
  
  *ARCHIVO DE FOLIO DESCARGADO DE LA PAGINA DE SII
  #define ArchivoFolio "C:\Datos\FoliosSII_FacturaAfecta.xml"
 
  Folio = 5
   
  vFecl = CreateObject("fecllib.Fecl")
  
  if vFecl:Autenticar(ArchivoCertificado, Clave)
	  vEnvio = vFecl:NuevoEnvioDTE
	  
	  vDTE = vEnvio:SetDTE
	  vCar = VDTE:Caratula
	  
	  vCar:RutEmisor = "97975000-5"
	  vCar:RutEnvia = "7880442-4"
	  vCar:RutReceptor = "60803000-K"
	  vCar:FchResol = "2003-09-02"
	  vCar:NroResol = 0
	  vCar:TmstFirmaEnv = ""
	  vCar:AgregaSubTotDTE(33, 1)
	  
	  vSetDTE = vEnvio:SetDTE
  
      vDoc = vEnvio:SetDTE:DTE(0):Documento
      vDoc:Encabezado:IdDoc:TipoDTE = 33
      vDoc:Encabezado:IdDoc:Folio = Folio
      vDoc:Encabezado:IdDoc:FchEmis = transform(year(date()),"@L 9999") + "-" + transform(month(date()),"@L 99") + "-" + transform(day(date()),"@L 99")
    
      vDoc:Encabezado:Emisor:RutEmisor = vCar:RutEmisor
      vDoc:Encabezado:Emisor:RznSoc = "RUT DE PRUEBA"
      vDoc:Encabezado:Emisor:GiroEmis = "Insumos de Computacion"
      vDoc:Encabezado:Emisor:AgregaActeco (31341)
      vDoc:Encabezado:Emisor:DirOrigen = "Teatinos 120, Piso 4"
      vDoc:Encabezado:Emisor:CmnaOrigen = "Santiago"

      vDoc:Encabezado:Receptor:RUTRecep = vCar:RutReceptor
      vDoc:Encabezado:Receptor:RznSocRecep = "EMPRESA  LTDA"
      vDoc:Encabezado:Receptor:GiroRecep = "COMPUTACION"
      vDoc:Encabezado:Receptor:DirRecep = "SAN DIEGO 2222"
      vDoc:Encabezado:Receptor:CmnaRecep = "LA FLORIDA"

      vDoc:Encabezado:Totales:MntNeto = 171639
      vDoc:Encabezado:Totales:TasaIVA = 19
      vDoc:Encabezado:Totales:IVA = 32611
      vDoc:Encabezado:Totales:MntTotal = 204250

      vDoc:Detalle(0):NroLinDet = 1
      vDoc:Detalle(0):TpoCodigo = "INT1"
      vDoc:Detalle(0):VlrCodigo = "011"
      vDoc:Detalle(0):NmbItem = "Cajn AFECTO"
      vDoc:Detalle(0):DscItem = "Cajn AFECTO"
      vDoc:Detalle(0):QtyItem = 122
      vDoc:Detalle(0):PrcItem = 833
      vDoc:Detalle(0):MontoItem = 101626

      vDoc:Detalle(1):NroLinDet = 2
      vDoc:Detalle(1):TpoCodigo = "INT1"
      vDoc:Detalle(1):VlrCodigo = "0231"
      vDoc:Detalle(1):NmbItem = "Relleno AFECTO"
      vDoc:Detalle(1):DscItem = "Relleno AFECTO"
      vDoc:Detalle(1):QtyItem = 53
      vDoc:Detalle(1):PrcItem = 1321
      vDoc:Detalle(1):MontoItem = 70013
    
      vDoc:TED:RE = vDoc:Encabezado:Emisor:RutEmisor
      vDoc:TED:TD = vDoc:Encabezado:IdDoc:TipoDTE
      vDoc:TED:F = vDoc:Encabezado:IdDoc:Folio
      vDoc:TED:FE = vDoc:Encabezado:IdDoc:FchEmis
      vDoc:TED:RR = vDoc:Encabezado:Receptor:RUTRecep
      vDoc:TED:RSR = vDoc:Encabezado:Receptor:RznSocRecep
      vDoc:TED:MNT = vDoc:Encabezado:Totales:MntTotal
      vDoc:TED:IT1 = vDoc:Detalle(0):DscItem
      vDoc:TED:CAF:CargaDesdeArchivo(ArchivoFolio)
     
      vEnvio:Firma()
      
      If vFecl:EnviarDTE()
        MessageBox(0, "DTE enviado con xito! TrackID: " + vFecl:TrackID, "FECL", 0)
      Else
        MessageBox(0, vFecl:ErrorDesc, "FECL", 0)
      EndIf
    
  Else
      MessageBox(0, vFecl:ErrorDesc, "FECL", 0)
  EndIf 
  
   
 
  
