package com.bitingenieria.fecl  ;

import com4j.*;

/**
 * Defines methods to create COM objects
 */
public abstract class ClassFactory {
  private ClassFactory() {} // instanciation is not allowed


  /**
   * Fecl Object
   */
  public static com.bitingenieria.fecl.IFecl createFecl() {
    return COM4J.createInstance( com.bitingenieria.fecl.IFecl.class, "{F2F78079-A110-44BD-A857-4C93A9D3CD28}" );
  }

  public static com.bitingenieria.fecl.ISetDTE createSetDTE() {
    return COM4J.createInstance( com.bitingenieria.fecl.ISetDTE.class, "{8073AA86-27F7-4D8E-B865-DCC7CDF4E837}" );
  }

  public static com.bitingenieria.fecl.ICaratula createCaratula() {
    return COM4J.createInstance( com.bitingenieria.fecl.ICaratula.class, "{5C4D9E2C-BA62-47E7-AB80-6CB86DDDA09C}" );
  }

  public static com.bitingenieria.fecl.IDTE createDTE() {
    return COM4J.createInstance( com.bitingenieria.fecl.IDTE.class, "{1B9A6B2C-81FF-4771-9CFD-0277563A346C}" );
  }

  public static com.bitingenieria.fecl.IDocumento createDocumento() {
    return COM4J.createInstance( com.bitingenieria.fecl.IDocumento.class, "{1FCBDFE8-30EA-47FB-B1F5-E673155B0554}" );
  }

  public static com.bitingenieria.fecl.ILiquidacion createLiquidacion() {
    return COM4J.createInstance( com.bitingenieria.fecl.ILiquidacion.class, "{FF6CBAA9-68C7-4D20-AD28-1BEB256E4245}" );
  }

  public static com.bitingenieria.fecl.IExportaciones createExportaciones() {
    return COM4J.createInstance( com.bitingenieria.fecl.IExportaciones.class, "{975A7675-100F-4A28-BD77-E146D27D3E85}" );
  }

  public static com.bitingenieria.fecl.IEncabezado createEncabezado() {
    return COM4J.createInstance( com.bitingenieria.fecl.IEncabezado.class, "{E9BF20F7-7D99-4061-A605-D402BB96BE26}" );
  }

  public static com.bitingenieria.fecl.IDetalle createDetalle() {
    return COM4J.createInstance( com.bitingenieria.fecl.IDetalle.class, "{1A502EB3-0066-484D-96B0-D4165775CA9B}" );
  }

  public static com.bitingenieria.fecl.ITED createTED() {
    return COM4J.createInstance( com.bitingenieria.fecl.ITED.class, "{37AFEA9B-8984-443D-9483-C58906F9CE49}" );
  }

  public static com.bitingenieria.fecl.IIdDoc createIdDoc() {
    return COM4J.createInstance( com.bitingenieria.fecl.IIdDoc.class, "{106ED332-D50C-4F3F-8F5A-8605E319A458}" );
  }

  public static com.bitingenieria.fecl.IEmisor createEmisor() {
    return COM4J.createInstance( com.bitingenieria.fecl.IEmisor.class, "{C9BA3930-E73D-49C3-81D1-E413784DA658}" );
  }

  public static com.bitingenieria.fecl.IReceptor createReceptor() {
    return COM4J.createInstance( com.bitingenieria.fecl.IReceptor.class, "{32080185-44BB-4204-B55A-7CCA605010E2}" );
  }

  public static com.bitingenieria.fecl.ITotales createTotales() {
    return COM4J.createInstance( com.bitingenieria.fecl.ITotales.class, "{959CEB65-8BA4-4CA4-ADAB-746AC335C252}" );
  }

  public static com.bitingenieria.fecl.IEnvioDTE createEnvioDTE() {
    return COM4J.createInstance( com.bitingenieria.fecl.IEnvioDTE.class, "{F0C7FAD3-A1AF-4099-8DD7-7726C38D640D}" );
  }

  public static com.bitingenieria.fecl.ICAF createCAF() {
    return COM4J.createInstance( com.bitingenieria.fecl.ICAF.class, "{F867D19E-C000-4772-A199-95FF7DC0DF6A}" );
  }

  public static com.bitingenieria.fecl.IRSAPK createRSAPK() {
    return COM4J.createInstance( com.bitingenieria.fecl.IRSAPK.class, "{69E2FFA9-894A-4F81-A70E-754C511AFEF9}" );
  }

  public static com.bitingenieria.fecl.IDSAPK createDSAPK() {
    return COM4J.createInstance( com.bitingenieria.fecl.IDSAPK.class, "{C1AF6087-8262-4980-981A-835B34EB05B8}" );
  }

  public static com.bitingenieria.fecl.IReferencia createReferencia() {
    return COM4J.createInstance( com.bitingenieria.fecl.IReferencia.class, "{D7657942-99AA-42BD-808A-92D81106B747}" );
  }

  public static com.bitingenieria.fecl.IDscRcgGlobal createDscRcgGlobal() {
    return COM4J.createInstance( com.bitingenieria.fecl.IDscRcgGlobal.class, "{D9C47B22-557C-4C0F-BAAD-720AC16F5760}" );
  }

  public static com.bitingenieria.fecl.ILEncabezado createLEncabezado() {
    return COM4J.createInstance( com.bitingenieria.fecl.ILEncabezado.class, "{C596AD8F-C516-4474-9A32-ED4211CD195C}" );
  }

  public static com.bitingenieria.fecl.ILDetalle createLDetalle() {
    return COM4J.createInstance( com.bitingenieria.fecl.ILDetalle.class, "{37572FF9-A0C7-4D32-AED3-07116E15616C}" );
  }

  public static com.bitingenieria.fecl.ILSubTotInfo createLSubTotInfo() {
    return COM4J.createInstance( com.bitingenieria.fecl.ILSubTotInfo.class, "{541B8772-4587-4117-86E1-C0669480669F}" );
  }

  public static com.bitingenieria.fecl.ILReferencia createLReferencia() {
    return COM4J.createInstance( com.bitingenieria.fecl.ILReferencia.class, "{4630DE28-FED0-47E3-966C-74266BBF82D1}" );
  }

  public static com.bitingenieria.fecl.IDocumento createLComisiones() {
    return COM4J.createInstance( com.bitingenieria.fecl.IDocumento.class, "{59180B72-2B80-42F1-A3ED-931E7772EAF4}" );
  }

  public static com.bitingenieria.fecl.IConsultaEstadoEnvioRespuesta createConsultaEstadoEnvioRespuesta() {
    return COM4J.createInstance( com.bitingenieria.fecl.IConsultaEstadoEnvioRespuesta.class, "{0E3D9953-94C1-4D1F-A276-ED89F07FC9F4}" );
  }

  public static com.bitingenieria.fecl.IConsultaEstadoDTERespuesta createConsultaEstadoDTERespuesta() {
    return COM4J.createInstance( com.bitingenieria.fecl.IConsultaEstadoDTERespuesta.class, "{7FC8CD75-5AAB-485E-863F-5A4689268CB1}" );
  }

  public static com.bitingenieria.fecl.ILibroCompraVenta createLibroCompraVenta() {
    return COM4J.createInstance( com.bitingenieria.fecl.ILibroCompraVenta.class, "{D42E390A-7EF6-4F91-B3E3-A8BFF24CBE05}" );
  }

  public static com.bitingenieria.fecl.IEnvioLibro createEnvioLibro() {
    return COM4J.createInstance( com.bitingenieria.fecl.IEnvioLibro.class, "{6A6E6EC0-A8C2-437F-ADA5-C71E8B771144}" );
  }

  public static com.bitingenieria.fecl.IELCaratula createELCaratula() {
    return COM4J.createInstance( com.bitingenieria.fecl.IELCaratula.class, "{891CA16B-EE00-4343-B108-E3660757D95C}" );
  }

  public static com.bitingenieria.fecl.IResumenSegmento createResumenSegmento() {
    return COM4J.createInstance( com.bitingenieria.fecl.IResumenSegmento.class, "{0A55EDB0-0AB4-4292-9A3D-F1CD9E849D88}" );
  }

  public static com.bitingenieria.fecl.IResumenPeriodo createResumenPeriodo() {
    return COM4J.createInstance( com.bitingenieria.fecl.IResumenPeriodo.class, "{38DF5394-3A03-4126-B3B7-0027A69A105F}" );
  }

  public static com.bitingenieria.fecl.IELDetalle createELDetalle() {
    return COM4J.createInstance( com.bitingenieria.fecl.IELDetalle.class, "{FB44AF2C-54CF-42F8-B0E8-0E96E32888AD}" );
  }

  public static com.bitingenieria.fecl.ISiiLceCal createSiiLceCal() {
    return COM4J.createInstance( com.bitingenieria.fecl.ISiiLceCal.class, "{A89F1325-9D58-40DC-A796-DCB71D8E5A68}" );
  }

  public static com.bitingenieria.fecl.ILceCoCertif createLceCoCertif() {
    return COM4J.createInstance( com.bitingenieria.fecl.ILceCoCertif.class, "{E6D9F76A-9F3D-401A-9413-F030AFD44F8F}" );
  }

  public static com.bitingenieria.fecl.ITotalesSegmento createTotalesSegmento() {
    return COM4J.createInstance( com.bitingenieria.fecl.ITotalesSegmento.class, "{BEA6A355-AC2F-4619-B42B-9B2542591385}" );
  }

  public static com.bitingenieria.fecl.ITotIVANoRec createTotIVANoRec() {
    return COM4J.createInstance( com.bitingenieria.fecl.ITotIVANoRec.class, "{677504E4-BF03-4EFB-831F-DB3655263FA7}" );
  }

  public static com.bitingenieria.fecl.ITotOtrosImp createTotOtrosImp() {
    return COM4J.createInstance( com.bitingenieria.fecl.ITotOtrosImp.class, "{6DF5AA47-95F8-4523-AB68-20733E43B72F}" );
  }

  public static com.bitingenieria.fecl.ITotLiquidaciones createTotLiquidaciones() {
    return COM4J.createInstance( com.bitingenieria.fecl.ITotLiquidaciones.class, "{25B78BBF-72FB-4478-9D40-93B74931E208}" );
  }

  public static com.bitingenieria.fecl.ITotalesPeriodo createTotalesPeriodo() {
    return COM4J.createInstance( com.bitingenieria.fecl.ITotalesPeriodo.class, "{80391DDB-B0D1-4EC5-84D6-89B56D535676}" );
  }

  public static com.bitingenieria.fecl.IExtranjero createExtranjero() {
    return COM4J.createInstance( com.bitingenieria.fecl.IExtranjero.class, "{96B01BED-E045-4FE0-804E-02748A554AD5}" );
  }

  public static com.bitingenieria.fecl.IIVANoRec createIVANoRec() {
    return COM4J.createInstance( com.bitingenieria.fecl.IIVANoRec.class, "{77C72325-B574-495B-B803-1D56F4EF847C}" );
  }

  public static com.bitingenieria.fecl.IOtrosImp createOtrosImp() {
    return COM4J.createInstance( com.bitingenieria.fecl.IOtrosImp.class, "{33670A0C-62C5-4A18-8718-4B049D741E44}" );
  }

  public static com.bitingenieria.fecl.IELDetLiquidacion createELDetLiquidacion() {
    return COM4J.createInstance( com.bitingenieria.fecl.IELDetLiquidacion.class, "{659342DD-89E1-4253-A60B-4DF0431A1EF8}" );
  }

  /**
   * Impresion Object
   */
  public static com.bitingenieria.fecl.IImpresion createImpresion() {
    return COM4J.createInstance( com.bitingenieria.fecl.IImpresion.class, "{6DC26B46-4F39-481A-9AFD-F6C5FF95DDEB}" );
  }

  public static com.bitingenieria.fecl.IEnvioBoleta createEnvioBoleta() {
    return COM4J.createInstance( com.bitingenieria.fecl.IEnvioBoleta.class, "{1CBDD4F1-3399-4473-A39E-1156F27B8B8A}" );
  }

  public static com.bitingenieria.fecl.INodo createNodo() {
    return COM4J.createInstance( com.bitingenieria.fecl.INodo.class, "{6B0FF181-5BBA-443B-ACFA-17BB042574D8}" );
  }

  public static com.bitingenieria.fecl.IRespuestaDTE createRespuestaDTE() {
    return COM4J.createInstance( com.bitingenieria.fecl.IRespuestaDTE.class, "{1912CF4E-3892-4B5B-9F8F-0EEFF6855F56}" );
  }

  public static com.bitingenieria.fecl.IEnvioRecibos createEnvioRecibos() {
    return COM4J.createInstance( com.bitingenieria.fecl.IEnvioRecibos.class, "{A6527765-03D7-4637-817C-894BC2560024}" );
  }

  public static com.bitingenieria.fecl.ILibroGuia createLibroGuia() {
    return COM4J.createInstance( com.bitingenieria.fecl.ILibroGuia.class, "{A4137E83-98FF-4209-9607-EFA80D694DCC}" );
  }

  /**
   * MailOpts Object
   */
  public static com.bitingenieria.fecl.IMailOpts createMailOpts() {
    return COM4J.createInstance( com.bitingenieria.fecl.IMailOpts.class, "{B6F556D6-3136-4A3A-AB49-813C30A9F07C}" );
  }

  public static com.bitingenieria.fecl.IAec createAec() {
    return COM4J.createInstance( com.bitingenieria.fecl.IAec.class, "{2B9C9E3F-4DEE-46EA-8B81-05BE04FB32CB}" );
  }

  public static com.bitingenieria.fecl.ILibroBoleta createLibroBoleta() {
    return COM4J.createInstance( com.bitingenieria.fecl.ILibroBoleta.class, "{F2797DCE-278D-41E3-B973-522533BF05C8}" );
  }

  public static com.bitingenieria.fecl.IReporteFolios createReporteFolios() {
    return COM4J.createInstance( com.bitingenieria.fecl.IReporteFolios.class, "{316D5FD9-69BF-4141-BAB8-1A70AA93F373}" );
  }

  public static com.bitingenieria.fecl.IObtenerConfirmacionesEmailRespuesta createObtenerConfirmacionesEmailRespuesta() {
    return COM4J.createInstance( com.bitingenieria.fecl.IObtenerConfirmacionesEmailRespuesta.class, "{25C5D4C2-4D48-4A83-B2C3-6ADC271FA6DF}" );
  }
}
