package com.bitingenieria.fecl  ;

import com4j.*;

/**
 * Dispatch interface for Fecl Object
 */
@IID("{7FD33FC1-057B-4E7E-A9B4-3B8B68821559}")
public interface IFecl extends Com4jObject {
  // Methods:
  /**
   * @param archivoCertificado Mandatory java.lang.String parameter.
   * @param archivoClave Mandatory java.lang.String parameter.
   * @return  Returns a value of type boolean
   */

  @DISPID(201) //= 0xc9. The runtime will prefer the VTID if present
  @VTID(7)
  boolean autenticar(
    java.lang.String archivoCertificado,
    java.lang.String archivoClave);


  /**
   * @return  Returns a value of type boolean
   */

  @DISPID(202) //= 0xca. The runtime will prefer the VTID if present
  @VTID(8)
  boolean enviarDTE();


  /**
   * <p>
   * Getter method for the COM property "Error"
   * </p>
   * @return  Returns a value of type int
   */

  @DISPID(203) //= 0xcb. The runtime will prefer the VTID if present
  @VTID(9)
  int error();


  /**
   * <p>
   * Getter method for the COM property "ErrorDesc"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(204) //= 0xcc. The runtime will prefer the VTID if present
  @VTID(10)
  java.lang.String errorDesc();


  /**
   * <p>
   * Getter method for the COM property "Token"
   * </p>
   * @return  Returns a value of type int
   */

  @DISPID(205) //= 0xcd. The runtime will prefer the VTID if present
  @VTID(11)
  int token();


  /**
   * <p>
   * Getter method for the COM property "ModoProduccion"
   * </p>
   * @return  Returns a value of type boolean
   */

  @DISPID(206) //= 0xce. The runtime will prefer the VTID if present
  @VTID(12)
  boolean modoProduccion();


  /**
   * <p>
   * Setter method for the COM property "ModoProduccion"
   * </p>
   * @param value Mandatory boolean parameter.
   */

  @DISPID(206) //= 0xce. The runtime will prefer the VTID if present
  @VTID(13)
  void modoProduccion(
    boolean value);


  /**
   * <p>
   * Getter method for the COM property "TrackID"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(207) //= 0xcf. The runtime will prefer the VTID if present
  @VTID(14)
  java.lang.String trackID();


  /**
   * @return  Returns a value of type com.bitingenieria.fecl.IEnvioDTE
   */

  @DISPID(208) //= 0xd0. The runtime will prefer the VTID if present
  @VTID(15)
  com.bitingenieria.fecl.IEnvioDTE nuevoEnvioDTE();


  /**
   * <p>
   * Getter method for the COM property "XMLRequest"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(210) //= 0xd2. The runtime will prefer the VTID if present
  @VTID(16)
  java.lang.String xmlRequest();


  /**
   * <p>
   * Getter method for the COM property "XMLResponse"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(211) //= 0xd3. The runtime will prefer the VTID if present
  @VTID(17)
  java.lang.String xmlResponse();


  /**
   * <p>
   * Getter method for the COM property "Depurar"
   * </p>
   * @return  Returns a value of type boolean
   */

  @DISPID(212) //= 0xd4. The runtime will prefer the VTID if present
  @VTID(18)
  boolean depurar();


  /**
   * <p>
   * Setter method for the COM property "Depurar"
   * </p>
   * @param value Mandatory boolean parameter.
   */

  @DISPID(212) //= 0xd4. The runtime will prefer the VTID if present
  @VTID(19)
  void depurar(
    boolean value);


  /**
   * @param rut Mandatory int parameter.
   * @param dv Mandatory java.lang.String parameter.
   * @param trackID Mandatory java.lang.String parameter.
   * @return  Returns a value of type com.bitingenieria.fecl.IConsultaEstadoEnvioRespuesta
   */

  @DISPID(213) //= 0xd5. The runtime will prefer the VTID if present
  @VTID(20)
  com.bitingenieria.fecl.IConsultaEstadoEnvioRespuesta consultaEstadoEnvio(
    int rut,
    java.lang.String dv,
    java.lang.String trackID);


  /**
   * @param rutConsultante Mandatory int parameter.
   * @param dvConsultante Mandatory java.lang.String parameter.
   * @param rutCompania Mandatory int parameter.
   * @param dvCompania Mandatory java.lang.String parameter.
   * @param rutReceptor Mandatory int parameter.
   * @param dvReceptor Mandatory java.lang.String parameter.
   * @param tipoDte Mandatory int parameter.
   * @param folioDte Mandatory double parameter.
   * @param fechaEmisionDte Mandatory java.lang.String parameter.
   * @param montoDte Mandatory double parameter.
   * @return  Returns a value of type com.bitingenieria.fecl.IConsultaEstadoDTERespuesta
   */

  @DISPID(214) //= 0xd6. The runtime will prefer the VTID if present
  @VTID(21)
  com.bitingenieria.fecl.IConsultaEstadoDTERespuesta consultaEstadoDTE(
    int rutConsultante,
    java.lang.String dvConsultante,
    int rutCompania,
    java.lang.String dvCompania,
    int rutReceptor,
    java.lang.String dvReceptor,
    int tipoDte,
    double folioDte,
    java.lang.String fechaEmisionDte,
    double montoDte);


  /**
   * @return  Returns a value of type com.bitingenieria.fecl.ILibroCompraVenta
   */

  @DISPID(215) //= 0xd7. The runtime will prefer the VTID if present
  @VTID(22)
  com.bitingenieria.fecl.ILibroCompraVenta nuevoLibroCompraVenta();


  /**
   * @return  Returns a value of type boolean
   */

  @DISPID(216) //= 0xd8. The runtime will prefer the VTID if present
  @VTID(23)
  boolean enviarLibroCompraVenta();


  /**
   * @return  Returns a value of type com.bitingenieria.fecl.IRespuestaDTE
   */

  @DISPID(219) //= 0xdb. The runtime will prefer the VTID if present
  @VTID(24)
  com.bitingenieria.fecl.IRespuestaDTE nuevaRespuestaDTE();


  /**
   * @param remitenteNombre Mandatory java.lang.String parameter.
   * @param remitenteMail Mandatory java.lang.String parameter.
   * @param destinatarioNombre Mandatory java.lang.String parameter.
   * @param destinatarioMail Mandatory java.lang.String parameter.
   * @param asunto Mandatory java.lang.String parameter.
   * @param texto Mandatory java.lang.String parameter.
   * @return  Returns a value of type boolean
   */

  @DISPID(221) //= 0xdd. The runtime will prefer the VTID if present
  @VTID(25)
  boolean enviarRespuestaDTE(
    java.lang.String remitenteNombre,
    java.lang.String remitenteMail,
    java.lang.String destinatarioNombre,
    java.lang.String destinatarioMail,
    java.lang.String asunto,
    java.lang.String texto);


  /**
   * @return  Returns a value of type com.bitingenieria.fecl.IEnvioRecibos
   */

  @DISPID(222) //= 0xde. The runtime will prefer the VTID if present
  @VTID(26)
  com.bitingenieria.fecl.IEnvioRecibos nuevoEnvioRecibos();


  /**
   * @param remitenteNombre Mandatory java.lang.String parameter.
   * @param remitenteMail Mandatory java.lang.String parameter.
   * @param destinatarioNombre Mandatory java.lang.String parameter.
   * @param destinatarioMail Mandatory java.lang.String parameter.
   * @param asunto Mandatory java.lang.String parameter.
   * @param texto Mandatory java.lang.String parameter.
   * @return  Returns a value of type boolean
   */

  @DISPID(224) //= 0xe0. The runtime will prefer the VTID if present
  @VTID(27)
  boolean enviarEnvioRecibos(
    java.lang.String remitenteNombre,
    java.lang.String remitenteMail,
    java.lang.String destinatarioNombre,
    java.lang.String destinatarioMail,
    java.lang.String asunto,
    java.lang.String texto);


  /**
   * @return  Returns a value of type com.bitingenieria.fecl.ILibroGuia
   */

  @DISPID(225) //= 0xe1. The runtime will prefer the VTID if present
  @VTID(28)
  com.bitingenieria.fecl.ILibroGuia nuevoLibroGuia();


  /**
   * @return  Returns a value of type boolean
   */

  @DISPID(226) //= 0xe2. The runtime will prefer the VTID if present
  @VTID(29)
  boolean enviarLibroGuia();


  /**
   * <p>
   * Getter method for the COM property "MailSettings"
   * </p>
   * @return  Returns a value of type com.bitingenieria.fecl.IMailOpts
   */

  @DISPID(209) //= 0xd1. The runtime will prefer the VTID if present
  @VTID(30)
  com.bitingenieria.fecl.IMailOpts mailSettings();


  /**
   * @return  Returns a value of type com.bitingenieria.fecl.IAec
   */

  @DISPID(217) //= 0xd9. The runtime will prefer the VTID if present
  @VTID(31)
  com.bitingenieria.fecl.IAec nuevoAec();


  /**
   */

  @DISPID(218) //= 0xda. The runtime will prefer the VTID if present
  @VTID(32)
  void licencia();


  /**
   * @param remitenteNombre Mandatory java.lang.String parameter.
   * @param remitenteMail Mandatory java.lang.String parameter.
   * @param destinatarioNombre Mandatory java.lang.String parameter.
   * @param destinatarioMail Mandatory java.lang.String parameter.
   * @param asunto Mandatory java.lang.String parameter.
   * @param texto Mandatory java.lang.String parameter.
   * @return  Returns a value of type boolean
   */

  @DISPID(220) //= 0xdc. The runtime will prefer the VTID if present
  @VTID(33)
  boolean enviarDTEMail(
    java.lang.String remitenteNombre,
    java.lang.String remitenteMail,
    java.lang.String destinatarioNombre,
    java.lang.String destinatarioMail,
    java.lang.String asunto,
    java.lang.String texto);


  /**
   * @return  Returns a value of type com.bitingenieria.fecl.ILibroBoleta
   */

  @DISPID(223) //= 0xdf. The runtime will prefer the VTID if present
  @VTID(34)
  com.bitingenieria.fecl.ILibroBoleta nuevoLibroBoleta();


  /**
   * @return  Returns a value of type boolean
   */

  @DISPID(227) //= 0xe3. The runtime will prefer the VTID if present
  @VTID(35)
  boolean enviarLibroBoleta();


  /**
   * @return  Returns a value of type com.bitingenieria.fecl.IReporteFolios
   */

  @DISPID(228) //= 0xe4. The runtime will prefer the VTID if present
  @VTID(36)
  com.bitingenieria.fecl.IReporteFolios nuevoReporteFolios();


  /**
   * @return  Returns a value of type boolean
   */

  @DISPID(229) //= 0xe5. The runtime will prefer the VTID if present
  @VTID(37)
  boolean enviarReporteFolios();


  /**
   * <p>
   * Getter method for the COM property "ModoSimulacion"
   * </p>
   * @return  Returns a value of type boolean
   */

  @DISPID(230) //= 0xe6. The runtime will prefer the VTID if present
  @VTID(38)
  boolean modoSimulacion();


  /**
   * <p>
   * Setter method for the COM property "ModoSimulacion"
   * </p>
   * @param value Mandatory boolean parameter.
   */

  @DISPID(230) //= 0xe6. The runtime will prefer the VTID if present
  @VTID(39)
  void modoSimulacion(
    boolean value);


  /**
   * <p>
   * Getter method for the COM property "RutaLibreria"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(231) //= 0xe7. The runtime will prefer the VTID if present
  @VTID(40)
  java.lang.String rutaLibreria();


  /**
   * <p>
   * Getter method for the COM property "MsgAlertOff"
   * </p>
   * @return  Returns a value of type boolean
   */

  @DISPID(232) //= 0xe8. The runtime will prefer the VTID if present
  @VTID(41)
  boolean msgAlertOff();


  /**
   * <p>
   * Setter method for the COM property "MsgAlertOff"
   * </p>
   * @param value Mandatory boolean parameter.
   */

  @DISPID(232) //= 0xe8. The runtime will prefer the VTID if present
  @VTID(42)
  void msgAlertOff(
    boolean value);


  /**
   * @param host Mandatory java.lang.String parameter.
   * @param puerto Mandatory int parameter.
   * @param usuario Mandatory java.lang.String parameter.
   * @param contrasenia Mandatory java.lang.String parameter.
   * @param useTLS Mandatory com.bitingenieria.fecl.UseTLSEnum parameter.
   * @param inbox Mandatory java.lang.String parameter.
   * @param trackID Mandatory java.lang.String parameter.
   * @param rut Mandatory java.lang.String parameter.
   * @return  Returns a value of type com.bitingenieria.fecl.IObtenerConfirmacionesEmailRespuesta
   */

  @DISPID(233) //= 0xe9. The runtime will prefer the VTID if present
  @VTID(43)
  com.bitingenieria.fecl.IObtenerConfirmacionesEmailRespuesta obtenerConfirmacionesEmail(
    java.lang.String host,
    int puerto,
    java.lang.String usuario,
    java.lang.String contrasenia,
    com.bitingenieria.fecl.UseTLSEnum useTLS,
    java.lang.String inbox,
    java.lang.String trackID,
    java.lang.String rut);


  /**
   * @param host Mandatory java.lang.String parameter.
   * @param port Mandatory int parameter.
   * @param userName Mandatory java.lang.String parameter.
   * @param password Mandatory java.lang.String parameter.
   */

  @DISPID(234) //= 0xea. The runtime will prefer the VTID if present
  @VTID(44)
  void configurarMail(
    java.lang.String host,
    int port,
    java.lang.String userName,
    java.lang.String password);


  /**
   * @param rutEmisor Mandatory java.lang.String parameter.
   * @param dvEmisor Mandatory java.lang.String parameter.
   * @param tipoDoc Mandatory java.lang.String parameter.
   * @param folio Mandatory java.lang.String parameter.
   * @param accionDoc Mandatory java.lang.String parameter.
   * @return  Returns a value of type boolean
   */

  @DISPID(235) //= 0xeb. The runtime will prefer the VTID if present
  @VTID(45)
  boolean ingresarAceptacionReclamoDoc(
    java.lang.String rutEmisor,
    java.lang.String dvEmisor,
    java.lang.String tipoDoc,
    java.lang.String folio,
    java.lang.String accionDoc);


  /**
   * @param rutEmisor Mandatory java.lang.String parameter.
   * @param dvEmisor Mandatory java.lang.String parameter.
   * @param tipoDoc Mandatory java.lang.String parameter.
   * @param folio Mandatory java.lang.String parameter.
   * @return  Returns a value of type boolean
   */

  @DISPID(236) //= 0xec. The runtime will prefer the VTID if present
  @VTID(46)
  boolean consultarDocDteCedible(
    java.lang.String rutEmisor,
    java.lang.String dvEmisor,
    java.lang.String tipoDoc,
    java.lang.String folio);


  /**
   * <p>
   * Getter method for the COM property "consultarDocDteCedibleRespuestaCodigo"
   * </p>
   * @return  Returns a value of type int
   */

  @DISPID(237) //= 0xed. The runtime will prefer the VTID if present
  @VTID(47)
  int consultarDocDteCedibleRespuestaCodigo();


  /**
   * <p>
   * Getter method for the COM property "consultarDocDteCedibleRespuestaDesc"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(238) //= 0xee. The runtime will prefer the VTID if present
  @VTID(48)
  java.lang.String consultarDocDteCedibleRespuestaDesc();


  /**
   * <p>
   * Getter method for the COM property "ingresarAceptacionReclamoDocRespuestaCodigo"
   * </p>
   * @return  Returns a value of type int
   */

  @DISPID(239) //= 0xef. The runtime will prefer the VTID if present
  @VTID(49)
  int ingresarAceptacionReclamoDocRespuestaCodigo();


  /**
   * <p>
   * Getter method for the COM property "ingresarAceptacionReclamoDocRespuestaDesc"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(240) //= 0xf0. The runtime will prefer the VTID if present
  @VTID(50)
  java.lang.String ingresarAceptacionReclamoDocRespuestaDesc();


  /**
   * @param rutEmpresa Mandatory java.lang.String parameter.
   * @return  Returns a value of type boolean
   */

  @DISPID(241) //= 0xf1. The runtime will prefer the VTID if present
  @VTID(51)
  boolean registroComprasGetResumen(
    java.lang.String rutEmpresa);


  /**
   * @return  Returns a value of type com.bitingenieria.fecl.IEnvioBoleta
   */

  @DISPID(242) //= 0xf2. The runtime will prefer the VTID if present
  @VTID(52)
  com.bitingenieria.fecl.IEnvioBoleta nuevoEnvioBoleta();


  /**
   * @return  Returns a value of type boolean
   */

  @DISPID(243) //= 0xf3. The runtime will prefer the VTID if present
  @VTID(53)
  boolean enviarBoleta();


  // Properties:
}
