package com.bitingenieria.fecl  ;

import com4j.*;

/**
 * Dispatch interface for Impresion Object
 */
@IID("{920DBF38-AC13-43DC-AC18-2D244194C7B3}")
public interface IImpresion extends Com4jObject {
  // Methods:
  /**
   * @param indiceDTE Mandatory int parameter.
   * @param plantilla Mandatory java.lang.String parameter.
   */

  @DISPID(201) //= 0xc9. The runtime will prefer the VTID if present
  @VTID(7)
  void editar(
    int indiceDTE,
    java.lang.String plantilla);


  /**
   * <p>
   * Getter method for the COM property "DirCasaMatriz"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(202) //= 0xca. The runtime will prefer the VTID if present
  @VTID(8)
  java.lang.String dirCasaMatriz();


  /**
   * <p>
   * Setter method for the COM property "DirCasaMatriz"
   * </p>
   * @param value Mandatory java.lang.String parameter.
   */

  @DISPID(202) //= 0xca. The runtime will prefer the VTID if present
  @VTID(9)
  void dirCasaMatriz(
    java.lang.String value);


  /**
   * @param indiceDTE Mandatory int parameter.
   * @param archivoSalida Mandatory java.lang.String parameter.
   * @param archivoPlantilla Mandatory java.lang.String parameter.
   * @param formatoSalida Mandatory java.lang.String parameter.
   */

  @DISPID(203) //= 0xcb. The runtime will prefer the VTID if present
  @VTID(10)
  void generar(
    int indiceDTE,
    java.lang.String archivoSalida,
    java.lang.String archivoPlantilla,
    java.lang.String formatoSalida);


  /**
   * <p>
   * Getter method for the COM property "AbrirArchivo"
   * </p>
   * @return  Returns a value of type boolean
   */

  @DISPID(204) //= 0xcc. The runtime will prefer the VTID if present
  @VTID(11)
  boolean abrirArchivo();


  /**
   * <p>
   * Setter method for the COM property "AbrirArchivo"
   * </p>
   * @param value Mandatory boolean parameter.
   */

  @DISPID(204) //= 0xcc. The runtime will prefer the VTID if present
  @VTID(12)
  void abrirArchivo(
    boolean value);


  /**
   * <p>
   * Getter method for the COM property "ArchivoLogo"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(205) //= 0xcd. The runtime will prefer the VTID if present
  @VTID(13)
  java.lang.String archivoLogo();


  /**
   * <p>
   * Setter method for the COM property "ArchivoLogo"
   * </p>
   * @param value Mandatory java.lang.String parameter.
   */

  @DISPID(205) //= 0xcd. The runtime will prefer the VTID if present
  @VTID(14)
  void archivoLogo(
    java.lang.String value);


  /**
   * @param campoSinEspacios Mandatory java.lang.String parameter.
   * @param valor Mandatory java.lang.String parameter.
   */

  @DISPID(206) //= 0xce. The runtime will prefer the VTID if present
  @VTID(15)
  void agregaExtraHead(
    java.lang.String campoSinEspacios,
    java.lang.String valor);


  /**
   * <p>
   * Getter method for the COM property "PDFStream"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(207) //= 0xcf. The runtime will prefer the VTID if present
  @VTID(16)
  java.lang.String pdfStream();


  /**
   * <p>
   * Getter method for the COM property "ErrorDesc"
   * </p>
   * @return  Returns a value of type java.lang.String
   */

  @DISPID(208) //= 0xd0. The runtime will prefer the VTID if present
  @VTID(17)
  java.lang.String errorDesc();


  // Properties:
}
